//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AAE80020166.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AAE80020166.cm

//## begin module%4AAE80020166.cp preserve=no
//## end module%4AAE80020166.cp

//## Module: PlotPkg%4AAE80020166; Package body
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotPkg.cxx

//## begin module%4AAE80020166.additionalIncludes preserve=no
//## end module%4AAE80020166.additionalIncludes

//## begin module%4AAE80020166.includes preserve=yes
#include <XSPlot/Plot/PlotTypes.h>
#include <XSUtil/Error/Error.h>
//## end module%4AAE80020166.includes

// PlotPane
#include <XSPlot/Plot/PlotPane.h>
// PlotPkg
#include <XSPlot/Plot/PlotPkg.h>


//## begin module%4AAE80020166.declarations preserve=no
//## end module%4AAE80020166.declarations

//## begin module%4AAE80020166.additionalDeclarations preserve=yes
//## end module%4AAE80020166.additionalDeclarations


// Class PlotPkg 

//## begin PlotPkg::vectorCategories%4AF98D27003E.attr preserve=no  public: static std::vector<PlotStyle::VectorCategory> {U} std::vector<PlotStyle::VectorCategory>()
std::vector<PlotStyle::VectorCategory> PlotPkg::s_vectorCategories = std::vector<PlotStyle::VectorCategory>();
//## end PlotPkg::vectorCategories%4AF98D27003E.attr

PlotPkg::PlotPkg()
  //## begin PlotPkg::PlotPkg%4AAE8A700152_const.hasinit preserve=no
  //## end PlotPkg::PlotPkg%4AAE8A700152_const.hasinit
  //## begin PlotPkg::PlotPkg%4AAE8A700152_const.initialization preserve=yes
  :m_deviceName(),
   m_shareXaxis(),
   m_panesInStack(),
   m_userCommands(0), // Non-owning
   m_isInteractive(false),
   m_plotPanes()
  //## end PlotPkg::PlotPkg%4AAE8A700152_const.initialization
{
  //## begin PlotPkg::PlotPkg%4AAE8A700152_const.body preserve=yes
   if (!s_vectorCategories.size())
   {
      s_vectorCategories.push_back(PlotStyle::DATA);
      s_vectorCategories.push_back(PlotStyle::BACKGROUND);
      s_vectorCategories.push_back(PlotStyle::MODEL);
      s_vectorCategories.push_back(PlotStyle::SOURCES);
   }
  //## end PlotPkg::PlotPkg%4AAE8A700152_const.body
}


PlotPkg::~PlotPkg()
{
  //## begin PlotPkg::~PlotPkg%4AAE8A700152_dest.body preserve=yes
   // Presumably PlotDirector would have cleared all PlotPanes
   // long before this gets destroyed, but this call can't hurt.
   clearPanes();
  //## end PlotPkg::~PlotPkg%4AAE8A700152_dest.body
}



//## Other Operations (implementation)
Real PlotPkg::BADVALUE () const
{
  //## begin PlotPkg::BADVALUE%4B1D55270040.body preserve=yes
   // Specific plotting packages can override this.
   return -999.999;
  //## end PlotPkg::BADVALUE%4B1D55270040.body
}

void PlotPkg::clearPanes () throw ()
{
  //## begin PlotPkg::clearPanes%4AE8B53C0360.body preserve=yes
  for (size_t i=0; i<m_plotPanes.size(); ++i)
     delete m_plotPanes[i];
  m_plotPanes.clear();
  //## end PlotPkg::clearPanes%4AE8B53C0360.body
}

void PlotPkg::display ()
{
  //## begin PlotPkg::display%4AEB62540157.body preserve=yes
   if (!m_deviceName.length())
      throw YellowAlert("Unable to Plot - No plot device has been set.\n");
   calculatePanePositions();   
      
   doInitialize();
   
   for (size_t i=0; i<m_plotPanes.size(); ++i)
   {
      setPanePosition(i);
      // The position of the setContour insertion is dictated 
      // specifically by PLT.  It performs best if the rescale commands
      // (in setPaneRanges) come AFTER the contour "xaxis/yaxis linear"
      // commands. 
      if (m_plotPanes[i]->isContour())
         setContourCmds(i);
      setPaneRanges(i);
      setPaneStyles(i);
      setPaneLabels(i);
      setPaneLineIDs(i);
   }
   
   doDisplay();
  //## end PlotPkg::display%4AEB62540157.body
}

void PlotPkg::flushHardcopy ()
{
  //## begin PlotPkg::flushHardcopy%4B59C4AB0358.body preserve=yes
  //## end PlotPkg::flushHardcopy%4B59C4AB0358.body
}

void PlotPkg::doInitialize ()
{
  //## begin PlotPkg::doInitialize%4B041907017C.body preserve=yes
  //## end PlotPkg::doInitialize%4B041907017C.body
}

void PlotPkg::setPanePosition (const size_t iPane)
{
  //## begin PlotPkg::setPanePosition%4B0419EC0263.body preserve=yes
  //## end PlotPkg::setPanePosition%4B0419EC0263.body
}

void PlotPkg::setPaneRanges (const size_t iPane)
{
  //## begin PlotPkg::setPaneRanges%4B041A4E0297.body preserve=yes
  //## end PlotPkg::setPaneRanges%4B041A4E0297.body
}

void PlotPkg::setPaneStyles (const size_t iPane)
{
  //## begin PlotPkg::setPaneStyles%4B041A7C01E1.body preserve=yes
  //## end PlotPkg::setPaneStyles%4B041A7C01E1.body
}

void PlotPkg::setPaneLabels (const size_t iPane)
{
  //## begin PlotPkg::setPaneLabels%4B041AAA01FA.body preserve=yes
  //## end PlotPkg::setPaneLabels%4B041AAA01FA.body
}

void PlotPkg::setPaneLineIDs (const size_t iPane)
{
  //## begin PlotPkg::setPaneLineIDs%4B5F5DB900F7.body preserve=yes
  //## end PlotPkg::setPaneLineIDs%4B5F5DB900F7.body
}

void PlotPkg::setContourCmds (const size_t iPane)
{
  //## begin PlotPkg::setContourCmds%4B55DF4E0145.body preserve=yes
  //## end PlotPkg::setContourCmds%4B55DF4E0145.body
}

void PlotPkg::calculatePanePositions ()
{
  //## begin PlotPkg::calculatePanePositions%4B0B0D1902BF.body preserve=yes
   // 9 independent coordinates for placing up to 6 panes in 2 stacks,
   // with or without shared X axis.  The coordinates refer to just the
   // actual viewport (in PLT parlance), and DO NOT encompass labels
   // and axis numerals.
   
   const Real x0 = 0.1;
   const Real y0 = 0.1;
   const Real dx1 = .8; // width of single pane plot
   const Real dy1 = .8; // height of single pane plot
   const Real dx2 = 0.35; // width of pane in 2 stack plot
   const Real stack2Gap = .15; // gap between 2 stacks
   const Real dyu = 0.5; // height of upper pane in shared X plot
   const Real dy2 = 0.32; // height of pane in a stack of 2, not shared X
   const Real dy3 = 0.19; // height of pane in a stack of 3, not shared X
   
   // Order of pane placement: If plot commands are numbered 1-to-N from
   // left-to-right, place in window from top down and then left-to-right
   // order.  For example, "plot data model resid chisq" would be placed:
   //    data    resid
   //    model   chisq
   
   size_t iPane=0;
   const size_t nStacks = m_panesInStack.size();
   if (nStacks > 2)
      throw YellowAlert("Only 2 stacks of plot panes are currently handled.\n");
   
   for (size_t iStack=0; iStack<nStacks; ++iStack)
   {
      const bool isSharedX = m_shareXaxis[iStack];
      const size_t nInStack = m_panesInStack[iStack];
      if (nInStack > 3)
         throw YellowAlert("Only 3 panes may appear in a plot stack.\n");
      for (size_t jInStack=0; jInStack<nInStack; ++jInStack)
      {
         PlotRectangle position;
         // X values are the same regardless of isSharedX setting.
         if (iStack == 0)
         {
            position.x1 = x0;
            position.x2 = nStacks > 1 ? x0 + dx2 : x0 + dx1;
         }
         else // Must be 2nd and last stack.
         {
            position.x1 = x0 + dx2 + stack2Gap;
            position.x2 = position.x1 + dx2;
         }
         
         
         if (isSharedX)
         {
            switch (nInStack)
            {
               case 1:
                  // There must only be 1 stack.
                  position.y1 = y0;
                  position.y2 = y0 + dy1;
                  break;
               case 2:
                  // Upper pane will be taller
                  if (jInStack == 0)
                  {
                     position.y1 = y0 + dy1 - dyu;
                     position.y2 = y0 + dy1;
                  }
                  else
                  {
                     position.y1 = y0;
                     position.y2 = y0 + dy1 - dyu;
                  }
                  break;
               case 3:
               {
                  // All 3 panes are same height.
                  Real height = dy1/3.0;
                  position.y1 = y0 + dy1 - (jInStack+1)*height;
                  position.y2 = y0 + dy1 - jInStack*height;
                  
               }
               default:
                  break;
            }
         } // end if shared X
         else
         {
            // Not sharing X axis, must be at least 2 panes in stack.
            if (nInStack == 2)
            {
               if (jInStack == 0)
               {
                  position.y1 = y0 + dy1 - dy2;
                  position.y2 = y0 + dy1;
               }
               else
               {
                  position.y1 = y0;
                  position.y2 = y0 + dy2;
               }
            }
            else // 3 panes in stack
            {
               const Real gap = (dy1 - 3.0*dy3)/2.0;
               position.y1 = y0 + dy1 - jInStack*(gap+dy3) - dy3;
               position.y2 = y0 + dy1 - jInStack*(gap+dy3);
            }
         }
         m_plotPanes[iPane]->panePosition(position);
         m_plotPanes[iPane]->stackIndex(iStack);
         ++iPane;
      } // end loop over nInStack
   } // end loop over stacks
   
   
  //## end PlotPkg::calculatePanePositions%4B0B0D1902BF.body
}

// Additional Declarations
  //## begin PlotPkg%4AAE8A700152.declarations preserve=yes
  //## end PlotPkg%4AAE8A700152.declarations

//## begin module%4AAE80020166.epilog preserve=yes
//## end module%4AAE80020166.epilog
